<script setup lang="ts">
import { onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import { useRoute } from 'vue-router'
import type { Member } from '@/types/Member'
import { useMembersStore } from '@/stores/member'
import { usePermissionStore } from '@/stores/permission'
import Swal from 'sweetalert2'

const route = useRoute()
const headers = [
  {
    title: 'Photo',
    key: 'image'
  },
  {
    title: 'Id',
    key: 'id'
  },
  {
    title: 'Email',
    key: 'email'
  },
  {
    title: 'Username',
    key: 'username'
  },
  {
    title: 'Name',
    key: 'name'
  },
  {
    title: 'Tel',
    key: 'tel'
  },
  {
    title: 'Point',
    key: 'point'
  },
  {
    title: 'Gender',
    key: 'gender'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const permissionStore = usePermissionStore()
const memberStore = useMembersStore()
const search = ref('')

const refform = ref<VForm | null>(null)
const form = ref(false)
const loading = ref(false)

async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  memberStore.saveMember()
  Swal.fire({
  icon: "success",
  title: "Your work has been saved",
  showConfirmButton: false,
  timer: 1500
  })
}

onMounted(async () => {
  permissionStore.pushMember()
  await memberStore.getMembers()
})
</script>

<template>
  <v-toolbar flat style="background-color: #212121; color: white">
    <v-toolbar-title>Member</v-toolbar-title>
    <v-spacer></v-spacer>
    <v-text-field
      v-model="search"
      prepend-inner-icon="mdi-magnify"
      density="compact"
      label="Search"
      single-line
      flat
      hide-details
      variant="solo-filled"
      style="width: 1px; margin-left: 10px"
    ></v-text-field>
    
      <v-dialog v-model="memberStore.dialog" persistent width="500">
        <template v-slot:activator="{ props }">
          <v-btn
            v-bind="props"
            prepend-icon="mdi-plus"
            style="background-color: #c7a17a; color: white; margin-left: 10px;"
          >
            New Member
          </v-btn>
        </template>
        <v-card>
          <v-card-title>
            <span class="text-h5">Member</span>
          </v-card-title>
          <v-card-text>
            <v-form ref="refform" v-model="form" @submit.prevent="memberStore.onSubmit">
              <v-container>
                <v-row>
                  <v-col cols="12" sm="12" md="6">
                    <v-text-field
                      v-model="memberStore.editedMember.name"
                      :readonly="loading"
                      :rules="[(v) => !!v || 'Field is required']"
                      class="mb-2"
                      clearable
                      label="Name"
                    ></v-text-field>
                  </v-col>

                  <v-col cols="12" sm="12" md="6">
                    <v-text-field
                      v-model="memberStore.editedMember.email"
                      :readonly="loading"
                      :rules="[
                        (v) => !!v || 'Field is required',
                        (v) => /.+@.+\..+/.test(v) || 'Email must be valid'
                      ]"
                      class="mb-2"
                      clearable
                      label="Email"
                    ></v-text-field>
                  </v-col>

                  <v-col cols="12" sm="12" md="6">
                    <v-text-field
                      v-model="memberStore.editedMember.tel"
                      :readonly="loading"
                      :rules="[
                        (v) => !!v || 'Field is required',
                        (v) => /^[0-9()+\-]{10}$/.test(v) || 'Invalid telephone number'
                      ]"
                      clearable
                      label="Tel"
                      placeholder="Enter Member Tel"
                    ></v-text-field>
                  </v-col>

                  <v-col cols="12" sm="6" md="6">
                    <v-combobox
                      v-model="memberStore.editedMember.username"
                      class="mb-2"
                      clearable
                      label="Username"
                      :rules="[(v) => !!v || 'Please Fill Data']"
                      :return-object="false"
                    ></v-combobox>
                  </v-col>

                  <v-col cols="12" sm="6" md="6">
                    <v-combobox
                      v-model="memberStore.editedMember.gender"
                      class="mb-2"
                      clearable
                      label="Gender"
                      prepend-inner-icon="mdi-gender-male-female"
                      :rules="[(v) => !!v || 'Please Fill Data']"
                      :items="[
                        { title: 'Male', value: 'Male' },
                        { title: 'Female', value: 'Female' },
                        { title: 'Others', value: 'Others' }
                      ]"
                      :return-object="false"
                    ></v-combobox>
                  </v-col>
                  <v-col cols="12" sm="12" md="6">
                    <v-file-input
                      v-model="memberStore.editedMember.files"
                      :rules="[
                        (value) => {
                          return (
                            !value ||
                            !value.length ||
                            value[0].size < 5000000 ||
                            'Avatar size should be less than 5 MB!'
                          )
                        }
                      ]"
                      accept="image/png, image/jpeg"
                      label="Avatar"
                      placeholder="Pick an avatar"
                      prepend-icon="mdi-camera"
                    ></v-file-input>
                  </v-col>
                  <v-col cols="12" sm="12" md="6">
                    <v-img
                      :src="
                        'http://localhost:3000/images/members/' + memberStore.editedMember.image
                      "
                      width="100"
                    ></v-img>
                  </v-col>
                </v-row>
              </v-container>
            </v-form>
            <small>*indicates required field</small>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="primary" variant="text" @click="memberStore.closeDialog()"> Close </v-btn>
            <v-btn color="primary" variant="text" @click="save()"> Save </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>


    <!--Delete Dialog-->
    <v-dialog v-model="memberStore.dialogDelete" width="500px">
      <v-card>
        <br />
        <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
        <v-spacer></v-spacer>
        <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
        <v-card-title align="center" class="text-h10">
          This action cannot be undone.<br />
          All values associated with this field will be lost.
        </v-card-title>
        <v-spacer></v-spacer>
        <div align="center">
          <div style="margin: 0 auto; max-width: 400px">
            <v-btn
              block
              style="background-color: #e11d48"
              color="white"
              variant="text"
              @click="memberStore.deleteMember()"
            >
              Delete field
            </v-btn>
          </div>
        </div>
        <div align="center">
          <div
            style="
              margin: 0 auto;
              max-width: 400px;
              border: 1px solid #dfe1e6;
              border-radius: 5px;
              margin-top: 10px;
            "
          >
            <v-btn block color="primary" variant="text" @click="memberStore.closeDelete()">
              Cancel
            </v-btn>
          </div>
        </div>
        <v-spacer></v-spacer>
        <br />
      </v-card>
    </v-dialog>
  </v-toolbar>
  <div>
    <v-data-table v-model:search="search" :headers="headers" :items="memberStore.members">
      <template v-slot:top> </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="memberStore.editMember(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" @click="memberStore.deleteMemberConfirm(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:[`item.image`]="{ item }">
        <v-img
          :src="'http://localhost:3000/images/members/' + item.image"
          width="80"
          height="80"
        ></v-img>
      </template>
    </v-data-table>
  </div>
</template>
